#include <stdio.h>
#include <deque>
#include <stack>
#include <map>

using namespace std;

#define END 1
#define POP 2
#define INV 3
#define DUP 4
#define SWP 5
#define ADD 6
#define SUB 7
#define MUL 8
#define DIV 9
#define MOD 10
#define NUM1 11
#define NUM2 12
#define NUM3 13
#define NUM4 14
#define NUM5 15

typedef struct state_ {
	short op;
	short a[5];
} state;

int main() {
	while (1) {
		state startState, endState;
		int n, i, j;
		scanf("%d", &n);
		
		if (n == 0)
			break;
		
		//map<State, bool> visited;
		deque< stack<state> > q;
		
		for (i = 0; i < n; ++i) {
			scanf("%d", startState.a + i);
			scanf("%d", endState.a + i);
		}
		
		q.resize(1);
		//visited[startState] = 1;
		while (!q.empty()) {
			stack<state> &currentStack = q.front();
			if (currentStack.size() == 1 && currentStack.top() == endState) {
				printf("YOOHOO!\n");
				return 0;
			}
			q.pop_front();
			for (i = 2; i <= 15; ++i) {
				stack<state> newStack = currentStack;
				num = 1;
				state a, b, st;
				switch (i) {
					case POP:
						if (newStack.empty())
							goto continueFor;
						newStack.pop();
						break;
					case INV:
						if (newStack.empty())
							goto continueFor;
						st = newStack.top();
						for (j = 0; j < n; ++j)
							st.a[j] = -st.a[j];
						newStack.pop();
						newStack.push(st);
						break;
					case DUP:
						if (newStack.empty())
							goto continueFor;
						newStack.push(newStack.top());
						break;
					case SWP:
						if (newStack.size() < 2)
							goto continueFor;
						a = newStack.top();
						newStack.pop();
						b = newStack.top();
						newStack.pop();
						newStack.push(a);
						newStack.push(b);
						break;
					case ADD:
						if (newStack.size() < 2)
							goto continueFor;
						a = newStack.top();
						newStack.pop();
						b = newStack.top();
						newStack.pop();
						for (j = 0; j < n; ++j)
							st.a[j] = a.a[j] + b.a[j];
						newStack.push(st);
						break;
					case SUB:
						if (newStack.size() < 2)
							goto continueFor;
						a = newStack.top();
						newStack.pop();
						b = newStack.top();
						newStack.pop();
						for (j = 0; j < n; ++j)
							st.a[j] = a.a[j] - b.a[j];
						newStack.push(st);
						break;
					case MUL:
						if (newStack.size() < 2)
							goto continueFor;
						a = newStack.top();
						newStack.pop();
						b = newStack.top();
						newStack.pop();
						for (j = 0; j < n; ++j)
							st.a[j] = a.a[j] * b.a[j];
						newStack.push(st);
						break;
					case DIV:
						if (newStack.size() < 2)
							goto continueFor;
						a = newStack.top();
						newStack.pop();
						b = newStack.top();
						newStack.pop();
						for (j = 0; j < n; ++j)
							st.a[j] = a.a[j] / b.a[j];
						newStack.push(st);
						break;
					case MOD:
						if (newStack.size() < 2)
							goto continueFor;
						a = newStack.top();
						newStack.pop();
						b = newStack.top();
						newStack.pop();
						for (j = 0; j < n; ++j)
							st.a[j] = a.a[j] % b.a[j];
						newStack.push(st);
						break;
						
					case NUM5:
						++num;
					case NUM4:
						++num;
					case NUM3:
						++num;
					case NUM2:
						++num;
					case NUM1:
						for (j = 0; j < n; ++j)
							st.a[j] = num;
						break;
				}
				q.push_back(newStack);
			continueFor: ;
			}
		}
	}
	return 0;
}
