#include <stdio.h>
#include <deque>
#include <map>

#define END 1
#define POP 2
#define INV 3
#define DUP 4
#define SWP 5
#define ADD 6
#define SUB 7
#define MUL 8
#define DIV 9
#define MOD 10
#define NUM1 11
#define NUM2 12
#define NUM3 13
#define NUM4 14
#define NUM5 15

typedef struct State_ {
	short a[5];
} State;

typedef struct Parent_ {
	short op;
	State st;
} Parent;

int main() {
	while (1) {
		State startState, endState;
		int n, i;
		scanf("%d", &n);
		
		if (n == 0)
			break;
		
		map<State, Parent> visited;
		deque<State> q;
		
		for (i = 0; i < n; ++i) {
			scanf("%d", startState.a + i);
			scanf("%d", endState.a + i);
		}
		
		q.push_back(startState);
		visited[startState] = (Parent) { 0, 0, 0, 0, 0, 0 };
		while (!q.empty()) {
			State currentState = q.pop_front();
			for (i = 2; i <= 15; ++i) {
				switch (i) {
					case INV:
						break;
					case DUP:
						break;
					case SWP:
						break;
					case ADD:
						break;
					case SUB:
						break;
					case MUL:
						break;
					case DIV:
						break;
					case MOD:
						break;
					case ADD:
						break;
					case ADD:
						break;
					case ADD:
						break;
					case ADD:
						break;
					case ADD:
						break;
					case ADD:
						break;
				}
			}
		}
	}
	return 0;
}
